Index: kernel/arch/sparc64/src/drivers/scr.c
===================================================================
--- kernel/arch/sparc64/src/drivers/scr.c	(revision 5d684e4c0dde4f587dd5aca281c366f71f72853b)
+++ kernel/arch/sparc64/src/drivers/scr.c	(revision 6ff1f1e849d8a798e3ed34a6dcdd58b2f25b0055)
@@ -41,4 +41,6 @@
 #include <align.h>
 #include <print.h>
+
+#define FFB_REG_24BPP	7
 
 scr_type_t scr_type = SCR_UNKNOWN;
@@ -121,5 +123,15 @@
 		
 		break;
-	case SCR_FFB:
+	case SCR_FFB:	
+		fb_depth = 24;
+		fb_scanline = 8192;
+
+		ofw_upa_reg_t *reg = &((ofw_upa_reg_t *) prop->value)[FFB_REG_24BPP];
+		if (!ofw_upa_apply_ranges(node->parent, reg, &fb_addr)) {
+			printf("Failed to determine screen address.\n");
+			return;
+		}
+
+		break;
 	default:
 		panic("Unexpected type.\n");
Index: kernel/genarch/Makefile.inc
===================================================================
--- kernel/genarch/Makefile.inc	(revision 5d684e4c0dde4f587dd5aca281c366f71f72853b)
+++ kernel/genarch/Makefile.inc	(revision 6ff1f1e849d8a798e3ed34a6dcdd58b2f25b0055)
@@ -99,4 +99,5 @@
 		genarch/src/ofw/ebus.c \
 		genarch/src/ofw/fhc.c \
-		genarch/src/ofw/pci.c 
+		genarch/src/ofw/pci.c  \
+		genarch/src/ofw/upa.c 
 endif
Index: kernel/genarch/include/ofw/ofw_tree.h
===================================================================
--- kernel/genarch/include/ofw/ofw_tree.h	(revision 5d684e4c0dde4f587dd5aca281c366f71f72853b)
+++ kernel/genarch/include/ofw/ofw_tree.h	(revision 6ff1f1e849d8a798e3ed34a6dcdd58b2f25b0055)
@@ -118,7 +118,9 @@
 typedef struct ofw_pci_range ofw_pci_range_t;
 
-struct ofw_ffb_reg {
+struct ofw_upa_reg {
+	uint64_t addr;
+	uint64_t size;
 } __attribute__ ((packed));
-typedef struct ofw_ffb_reg ofw_ffb_reg_t;
+typedef struct ofw_upa_reg ofw_upa_reg_t;
 
 extern void ofw_tree_init(ofw_tree_node_t *root);
@@ -132,5 +134,5 @@
 extern bool ofw_ebus_apply_ranges(ofw_tree_node_t *node, ofw_ebus_reg_t *reg, uintptr_t *pa);
 extern bool ofw_pci_apply_ranges(ofw_tree_node_t *node, ofw_pci_reg_t *reg, uintptr_t *pa);
-extern bool ofw_ffb_apply_ranges(ofw_tree_node_t *node, ofw_ffb_reg_t *reg, uintptr_t *pa);
+extern bool ofw_upa_apply_ranges(ofw_tree_node_t *node, ofw_upa_reg_t *reg, uintptr_t *pa);
 
 extern bool ofw_pci_reg_absolutize(ofw_tree_node_t *node, ofw_pci_reg_t *reg, ofw_pci_reg_t *out);
Index: kernel/genarch/src/ofw/upa.c
===================================================================
--- kernel/genarch/src/ofw/upa.c	(revision 6ff1f1e849d8a798e3ed34a6dcdd58b2f25b0055)
+++ kernel/genarch/src/ofw/upa.c	(revision 6ff1f1e849d8a798e3ed34a6dcdd58b2f25b0055)
@@ -0,0 +1,52 @@
+/*
+ * Copyright (C) 2006 Jakub Jermar
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup ofw
+ * @{
+ */
+/**
+ * @file
+ * @brief	UPA 'reg' and 'ranges' properties handling.
+ *
+ */
+
+#include <genarch/ofw/ofw_tree.h>
+#include <arch/memstr.h>
+#include <func.h>
+#include <panic.h>
+#include <macros.h>
+#include <debug.h>
+
+bool ofw_upa_apply_ranges(ofw_tree_node_t *node, ofw_upa_reg_t *reg, uintptr_t *pa)
+{
+	*pa = reg->addr;
+	return false;
+}
+
+/** @}
+ */
